OpenCL specific functions

- Main Page
- Tutorials
- Functions
- Release Notes
- Examples

OpenCL specific functions
ArrayFire Functions by Category » Interface Functions

Accessing ArrayFire's context, queue, and share data with other OpenCL code. More...

AFAPI af_err | afcl_get_context (cl_context *ctx, const bool retain)
| Get a handle to ArrayFire's OpenCL context. More...
AFAPI af_err | afcl_get_queue (cl_command_queue *queue, const bool retain)
| Get a handle to ArrayFire's OpenCL command queue. More...
AFAPI af_err | afcl_get_device_id (cl_device_id *id)
| Get the device ID for ArrayFire's current active device. More...
AFAPI af_err | afcl_set_device_id (cl_device_id id)
| Set ArrayFire's active device based on `id` of type cl_device_id. More...
AFAPI af_err | afcl_add_device_context (cl_device_id dev, cl_context ctx, cl_command_queue que)
| Push user provided device control constructs into the ArrayFire device manager pool. More...
AFAPI af_err | afcl_set_device_context (cl_device_id dev, cl_context ctx)
| Set active device using cl_context and cl_device_id. More...
AFAPI af_err | afcl_delete_device_context (cl_device_id dev, cl_context ctx)
| Remove the user provided device control constructs from the ArrayFire device manager pool. More...
AFAPI af_err | afcl_get_device_type (afcl_device_type *res)
| Get the type of the current device. More...
AFAPI af_err | afcl_get_platform (afcl_platform *res)
| Get the platform of the current device. More...
static cl_context | getContext (bool retain=false)
| Get a handle to ArrayFire's OpenCL context. More...

## Detailed Description

Accessing ArrayFire's context, queue, and share data with other OpenCL code.

If your software is using ArrayFire's OpenCL backend, you can also write custom kernels and do custom memory operations using native OpenCL commands. The functions contained in the `afcl` namespace provide methods to get the context, queue, and device(s) that ArrayFire is using as well as convert `cl_mem` handles to af::array objects.

Please note: the af::array constructors are not thread safe. You may create and upload data to `cl_mem` objects from separate threads, but the thread which instantiated ArrayFire must do the `cl_mem` to af::array conversion.

## Function Documentation

AFAPI af_err afcl_add_device_context | ( | cl_device_id | dev,
|  | cl_context | ctx,
|  | cl_command_queue | que
| ) |  |

Push user provided device control constructs into the ArrayFire device manager pool.

This function should be used only when the user would like ArrayFire to use an user generated OpenCL context and related objects for ArrayFire operations.

Parameters

  [in] | dev | is the OpenCL device for which user provided context will be used by ArrayFire
  [in] | ctx | is the user provided OpenCL cl_context to be used by ArrayFire
  [in] | que | is the user provided OpenCL cl_command_queue to be used by ArrayFire. If this parameter is NULL, then we create a command queue for the user using the OpenCL context they provided us.

Note
  ArrayFire does not take control of releasing the objects passed to it. The user needs to release them appropriately.

AFAPI af_err afcl_delete_device_context | ( | cl_device_id | dev,
|  | cl_context | ctx
| ) |  |

Remove the user provided device control constructs from the ArrayFire device manager pool.

This function should be used only when the user would like ArrayFire to remove an already pushed user generated OpenCL context and related objects.

Parameters

  [in] | dev | is the OpenCL device id that has to be popped
  [in] | ctx | is the cl_context object to be removed from ArrayFire pool

Note
  ArrayFire does not take control of releasing the objects passed to it. The user needs to release them appropriately.

AFAPI af_err afcl_get_context | ( | cl_context * | ctx,
|  | const bool | retain
| ) |  |

Get a handle to ArrayFire's OpenCL context.

Parameters

  [out] | ctx | the current context being used by ArrayFire
  [in] | retain | if true calls clRetainContext prior to returning the context

Returns
  af_err error code

Note
  Set `retain` to true if this value will be passed to a cl::Context constructor

AFAPI af_err afcl_get_device_id | ( | cl_device_id * | id | ) |

Get the device ID for ArrayFire's current active device.

Parameters

  [out] | id | the cl_device_id of the current device

Returns
  af_err error code

AFAPI af_err afcl_get_device_type | ( | afcl_device_type * | res | ) |

Get the type of the current device.

AFAPI af_err afcl_get_platform | ( | afcl_platform * | res | ) |

Get the platform of the current device.

AFAPI af_err afcl_get_queue | ( | cl_command_queue * | queue,
|  | const bool | retain
| ) |  |

Get a handle to ArrayFire's OpenCL command queue.

Parameters

  [out] | queue | the current command queue being used by ArrayFire
  [in] | retain | if true calls clRetainCommandQueue prior to returning the context

Returns
  af_err error code

Note
  Set `retain` to true if this value will be passed to a cl::CommandQueue constructor

AFAPI af_err afcl_set_device_context | ( | cl_device_id | dev,
|  | cl_context | ctx
| ) |  |

Set active device using cl_context and cl_device_id.

Parameters

  [in] | dev | is the OpenCL device id that is to be set as Active device inside ArrayFire
  [in] | ctx | is the OpenCL cl_context being used by ArrayFire

AFAPI af_err afcl_set_device_id | ( | cl_device_id | id | ) |

Set ArrayFire's active device based on `id` of type cl_device_id.

Parameters

  [in] | id | the cl_device_id of the device to be set as active device

Returns
  af_err error code

static cl_context afcl::getContext | ( | bool | retain = `false` | ) |
| inlinestatic

Get a handle to ArrayFire's OpenCL context.

Parameters

  [in] | retain | if true calls clRetainContext prior to returning the context

Returns
  the current context being used by ArrayFire

Note
  Set `retain` to true if this value will be passed to a cl::Context constructor